#!/usr/bin/perl


sub login {
  $dbh = $form->dbconnect(\%myconfig);
  $sth = $dbh->prepare("
	SELECT count(*) FROM customer WHERE login = ? AND passwd = MD5(?)"
  );
  $sth->execute($form->{login}, $form->{password});
  ($rc) = $sth->fetchrow_array;
  $sth->finish;

  if ($rc){
     while (!$session_id){
       &get_session_id;
       if (!$session_id){
          $sth = $dbh->prepare("INSERT INTO sessions (login) VALUES (?)");
          $sth->execute($form->{login});
       }
     }
  }
  $dbh->disconnect;
  $rc;
}

sub get_session_id {
  $sth = $dbh->prepare(
	"SELECT MAX(session_id) FROM sessions WHERE login = ?"
  );
  $sth->execute($form->{login});
  if (($session_id) = $sth->fetchrow_array){
       print qq|Set-Cookie: login=$form->{login}::session_id=$session_id; expires=$today; path=/;\n|;
  }
  $sth->finish;
  $session_id;
}

sub redirect {
  print "Location:$form->{callback}\n\n"; 
}

sub print_screen {
  for (qw(logopath address city state zip tel company email)) {
     $form->{$_} = $myconfig{$_}; 
  }
  if (!$form->{callback}){ 
    $form->{callback}= "http://$ENV{SERVER_NAME}/$defaultredirect";
  }
  $form->{formname}="index";
  $form->{format}="html";
  $form->{templates}=".";
  $form->{media}="screen";
  $form->parse_template(\%myconfig, '/home/seasoningsalt.com/tmp');
}

sub register{
  my $temp = $form;
  for (qw(name address1 address2 city state zipcode phone fax email)){
    $t = "customer$_";
    $temp->{$_} = $temp->{$t};
    $temp->{tel} = $temp->{phone};
  }
  if (&check_form){
    if (&check_login){
      $form->{password} = $form->{password1};

      use SL::CT;
      CT::save_customer("", \%myconfig, \%$form);
    }
  }
  if ($form->{id}){
    $dbh = $form->dbconnect(\%myconfig);
    $sth = $dbh->prepare("
	SELECT count(*) FROM customer WHERE login = ? AND passwd = MD5(?)"
    );
    $sth->execute($form->{login}, $form->{password});
    ($rc) = $sth->fetchrow_array;
    $sth->finish;

    if ($rc){
       while (!$session_id){
         &get_session_id;
         if (!$session_id){
            $sth = $dbh->prepare("INSERT INTO sessions (login) VALUES (?)");
            $sth->execute($form->{login});
         }
       }
    }
    $dbh->disconnect;
  }
}

sub check_login {
  my $dbh = $form->dbconnect(\%myconfig);
  my $sth = $dbh->prepare(" SELECT count(*) FROM customer WHERE login = ?");
  $sth->execute($form->{login});
  my ($rc) = $sth->fetchrow_array;
  !$rc;
  $sth->finish;
  $dbh->disconnect;
}

sub get_cookie_session_id {
  @cookies = split(/::/, $ENV{HTTP_COOKIE});
  for (@cookies){
    ($key, $value) = split(/=/, $_, 2);
    $form->{$key} = $value;
  }
  if (!$form->{session_id}){
    print "Location:login.pl\n\n";
  }
}

sub add_item {
  my $query = "INSERT INTO cart (session_id, parts_id, qty) VALUES (?, ?, ?)";
  my $dbh = $form->dbconnect(\%myconfig);
  my $sth = $dbh->prepare($query);
  $sth->execute($form->{session_id}, $form->{parts_id}, $form->{qty});
  
  $sth->finish;
  $dbh->disconnect;
}

sub destroy_session {
  print qq|Set-Cookie: login=0::session_id=0; expires=$today; path=/;\n|;
  my $dbh = $form->dbconnect(\%myconfg);
  my $sth = $dbh->prepare("DELETE FROM cart WHERE session_id = ?");
  $sth->execute($form->{session_id});
  $sth->finish;
  $sth = $dbh->prepare("DELETE from sessions where session_id = ?");
  $sth->execute($form->{session_id});
  $sth->finish;
  $dbh->disconnect;
}

sub get_cart_items {
  my $dbh = $form->dbconnect(\%myconfig);
  my $sth = $dbh->prepare("
	SELECT  p.id, c.qty, p.partnumber, p.description, 
		p.sellprice::numeric(100,2) as sellprice, 
		(c.qty * p.weight) as weight,
		(p.sellprice * c.qty)::numeric(100,2) AS extended, p.unit
	FROM cart c JOIN parts p ON (c.parts_id = p.id)
	WHERE c.session_id = ?
  ");
  $sth->execute($form->{session_id});
  $ordnum = 1;
  while ($ref = $sth->fetchrow_hashref()){
    $ref->{ordnum} = $ordnum;
    for (keys %{$ref}){
      push @{$form->{$_}}, $ref->{$_};
    }
    push @{$form->{lineitem}}, $ref;
    ++$ordnum;
  }
  $form->{rowcount} = $ordnum;
  $sth->finish;
  $dbh->disconnect;
}

sub get_customer_id {
  my $dbh = $form->dbconnect(\%myconfig);
  my $sth = $dbh->prepare("SELECT id FROM customer WHERE login = ?");
  $sth->execute($form->{login});
  ($form->{customer_id}) = $sth->fetchrow_array;
  $sth->finish;
  $dbh->disconnect;
}

sub get_full_cart {
  &get_cookie_session_id;
  &get_cart_items;
  $form->{total_wt} = 0;
  for (@{$form->{weight}}){ 
    $form->{total_wt} += $_;
  }
  $form->{total} = 0;
  for (@{$form->{extended}}){
    $form->{total} += $_;
  }
  $form->{lb} = $form->round_amount($form->{total_wt} / 16, 0);
  $form->{m_oz} = $form->{total_wt} % 16;
  $form->{zip} = $myconfig{zip};
  require "$myconfig{shipping_method}.pl"; # Calculate Postage
  $form->{total} += $form->{postage};
  $form->{total} = $form->round_amount($form->{total}, 2);
}

1;
